<html>
<head>
<title>OgreCodec.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreCodec.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreCodec_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _Codec_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _Codec_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringVector_8h.html">OgreStringVector.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreException_8h.html">OgreException.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00055"></a><a class="code" href="classOgre_1_1Codec.html">00055</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Codec.html" title="Abstract class that defines a &#39;codec&#39;.">Codec</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">CodecAlloc</a>
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057     <span class="keyword">protected</span>:
<a name="l00058"></a><a class="code" href="classOgre_1_1Codec.html#a9ae612c8caf1bcc5a5f44b72b73115ee">00058</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">map&lt; String, Codec* &gt;::type</a> <a class="code" href="classOgre_1_1Codec.html#a9ae612c8caf1bcc5a5f44b72b73115ee">CodecList</a>; 
<a name="l00061"></a><a class="code" href="classOgre_1_1Codec.html#a73c43a617f6b6fe273a9a17112e2458a">00061</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Codec.html#a9ae612c8caf1bcc5a5f44b72b73115ee">CodecList</a> <a class="code" href="classOgre_1_1Codec.html#a73c43a617f6b6fe273a9a17112e2458a" title="A map that contains all the registered codecs.">msMapCodecs</a>;
<a name="l00062"></a>00062 
<a name="l00063"></a>00063     <span class="keyword">public</span>:
<a name="l00064"></a><a class="code" href="classOgre_1_1Codec_1_1CodecData.html">00064</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#af4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1Codec_1_1CodecData.html">CodecData</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">CodecAlloc</a>
<a name="l00065"></a>00065         {
<a name="l00066"></a>00066         <span class="keyword">public</span>:
<a name="l00067"></a><a class="code" href="classOgre_1_1Codec_1_1CodecData.html#a8d1d3dc4a466a4e992aad72c14bf81eb">00067</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Codec_1_1CodecData.html#a8d1d3dc4a466a4e992aad72c14bf81eb">~CodecData</a>() {}
<a name="l00068"></a>00068 
<a name="l00071"></a><a class="code" href="classOgre_1_1Codec_1_1CodecData.html#ab2681263d0b7dafe3ff0afba729eeef4">00071</a>             <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Codec_1_1CodecData.html#ab2681263d0b7dafe3ff0afba729eeef4" title="Returns the type of the data.">dataType</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;CodecData&quot;</span>; }
<a name="l00072"></a>00072         };
<a name="l00073"></a><a class="code" href="classOgre_1_1Codec.html#a29e31ad112b08ea7fb648b63f426ff1f">00073</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;CodecData&gt;</a> <a class="code" href="classOgre_1_1Codec.html#a29e31ad112b08ea7fb648b63f426ff1f">CodecDataPtr</a>;
<a name="l00074"></a>00074 
<a name="l00075"></a><a class="code" href="classOgre_1_1Codec.html#a21f4b8a16d070793d576f827c9fee218">00075</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator&lt;CodecList&gt;</a> <a class="code" href="classOgre_1_1Codec.html#a21f4b8a16d070793d576f827c9fee218">CodecIterator</a>;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077     <span class="keyword">public</span>:
<a name="l00078"></a>00078         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Codec.html" title="Abstract class that defines a &#39;codec&#39;.">Codec</a>();
<a name="l00079"></a>00079         
<a name="l00082"></a><a class="code" href="classOgre_1_1Codec.html#a60f445cc6919df56af6611fd14eec47d">00082</a>         <span class="keyword">static</span> <span class="keywordtype">void</span> registerCodec( <a class="code" href="classOgre_1_1Codec.html" title="Abstract class that defines a &#39;codec&#39;.">Codec</a> *pCodec )
<a name="l00083"></a>00083         {
<a name="l00084"></a>00084             CodecList::iterator i = msMapCodecs.find(pCodec-&gt;<a class="code" href="classOgre_1_1Codec.html#ada1a5477ab6a563565f1b3599d7b806a" title="Returns the type of the codec as a String.">getType</a>());
<a name="l00085"></a>00085             <span class="keywordflow">if</span> (i != msMapCodecs.end())
<a name="l00086"></a>00086                 OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba932168f4c4ae1a90391233de8a21ab1a">Exception::ERR_DUPLICATE_ITEM</a>, 
<a name="l00087"></a>00087                     pCodec-&gt;<a class="code" href="classOgre_1_1Codec.html#ada1a5477ab6a563565f1b3599d7b806a" title="Returns the type of the codec as a String.">getType</a>() + <span class="stringliteral">&quot; already has a registered codec. &quot;</span>, __FUNCTION__);
<a name="l00088"></a>00088 
<a name="l00089"></a>00089             msMapCodecs[pCodec-&gt;<a class="code" href="classOgre_1_1Codec.html#ada1a5477ab6a563565f1b3599d7b806a" title="Returns the type of the codec as a String.">getType</a>()] = pCodec;
<a name="l00090"></a>00090         }
<a name="l00091"></a>00091 
<a name="l00094"></a><a class="code" href="classOgre_1_1Codec.html#ae5b74cfd0cb797a2ac139b4adb7ac557">00094</a>         <span class="keyword">static</span> <span class="keywordtype">bool</span> isCodecRegistered( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; codecType )
<a name="l00095"></a>00095         {
<a name="l00096"></a>00096             <span class="keywordflow">return</span> msMapCodecs.find(codecType) != msMapCodecs.end();
<a name="l00097"></a>00097         }
<a name="l00098"></a>00098 
<a name="l00101"></a><a class="code" href="classOgre_1_1Codec.html#ac1199a6638ff560aa81287cd12c26bcf">00101</a>         <span class="keyword">static</span> <span class="keywordtype">void</span> unRegisterCodec( <a class="code" href="classOgre_1_1Codec.html" title="Abstract class that defines a &#39;codec&#39;.">Codec</a> *pCodec )
<a name="l00102"></a>00102         {
<a name="l00103"></a>00103             msMapCodecs.erase(pCodec-&gt;<a class="code" href="classOgre_1_1Codec.html#ada1a5477ab6a563565f1b3599d7b806a" title="Returns the type of the codec as a String.">getType</a>());
<a name="l00104"></a>00104         }
<a name="l00105"></a>00105 
<a name="l00107"></a><a class="code" href="classOgre_1_1Codec.html#a55bf1d49e91958f8e412a583666bbd58">00107</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">CodecIterator</a> getCodecIterator(<span class="keywordtype">void</span>)
<a name="l00108"></a>00108         {
<a name="l00109"></a>00109             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">CodecIterator</a>(msMapCodecs.begin(), msMapCodecs.end());
<a name="l00110"></a>00110         }
<a name="l00111"></a>00111 
<a name="l00113"></a>00113         <span class="keyword">static</span> <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> getExtensions(<span class="keywordtype">void</span>);
<a name="l00114"></a>00114 
<a name="l00116"></a>00116         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Codec.html" title="Abstract class that defines a &#39;codec&#39;.">Codec</a>* getCodec(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; extension);
<a name="l00117"></a>00117 
<a name="l00124"></a>00124         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Codec.html" title="Abstract class that defines a &#39;codec&#39;.">Codec</a>* getCodec(<span class="keywordtype">char</span> *magicNumberPtr, <span class="keywordtype">size_t</span> maxbytes);
<a name="l00125"></a>00125 
<a name="l00129"></a>00129         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> code(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">MemoryDataStreamPtr</a>&amp; input, CodecDataPtr&amp; pData) <span class="keyword">const</span> = 0;
<a name="l00137"></a>00137         <span class="keyword">virtual</span> <span class="keywordtype">void</span> codeToFile(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">MemoryDataStreamPtr</a>&amp; input, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; outFileName, CodecDataPtr&amp; pData) <span class="keyword">const</span> = 0;
<a name="l00138"></a>00138 
<a name="l00140"></a><a class="code" href="classOgre_1_1Codec.html#a8cc81c85bd7d4e25393aa153c5e01454">00140</a>         <span class="keyword">typedef</span> std::pair&lt;MemoryDataStreamPtr, CodecDataPtr&gt; <a class="code" href="classOgre_1_1Codec.html#a8cc81c85bd7d4e25393aa153c5e01454" title="Result of a decoding; both a decoded data stream and CodecData metadata.">DecodeResult</a>;
<a name="l00146"></a>00146         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Codec.html#a8cc81c85bd7d4e25393aa153c5e01454" title="Result of a decoding; both a decoded data stream and CodecData metadata.">DecodeResult</a> decode(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; input) <span class="keyword">const</span> = 0;
<a name="l00147"></a>00147 
<a name="l00150"></a>00150         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getType() <span class="keyword">const</span> = 0;
<a name="l00151"></a>00151 
<a name="l00154"></a>00154         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getDataType() <span class="keyword">const</span> = 0;
<a name="l00155"></a>00155 
<a name="l00162"></a><a class="code" href="classOgre_1_1Codec.html#ae875657d0aa27ef91d934470f00dd9b5">00162</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> magicNumberMatch(<span class="keyword">const</span> <span class="keywordtype">char</span> *magicNumberPtr, <span class="keywordtype">size_t</span> maxbytes)<span class="keyword"> const </span>
<a name="l00163"></a>00163 <span class="keyword">        </span>{ <span class="keywordflow">return</span> !magicNumberToFileExt(magicNumberPtr, maxbytes).empty(); }
<a name="l00171"></a>00171         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> magicNumberToFileExt(<span class="keyword">const</span> <span class="keywordtype">char</span> *magicNumberPtr, <span class="keywordtype">size_t</span> maxbytes) <span class="keyword">const</span> = 0;
<a name="l00172"></a>00172     };
<a name="l00176"></a>00176 } <span class="comment">// namespace</span>
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
